 // --------------------- \\
// PC Mod - For Client \\
 // -------------------- \\

PCMod = {}
PCMod.Version = "12"
PCMod.Exists = true
PCMod.WireEnabled = 0

Msg( "=== PCMod Installed ===\n" )
Msg( "== PCMod Clientside OS (BETA Version " .. PCMod.Version .. ") Initialized ==\n" )

// Uses DMenu LUA Module
include( "cl_dmenu.lua" )

// Some globals
w = ScrW()
h = ScrH()

// Our current PC information
C_PC = {}
C_PC.Status = 0
C_PC.Online = false
C_PC.IP = ""
C_PC.PList = {}
C_PC.SysTray = {}
C_PC.DIcons = {}
CurrentPCIndex = 0
ScreenTexID = 0

PCLoaded = false

CurrentProgram = ""
CurrentPC = nil

PC_ScreenSizeX = 0
PC_ScreenSizeY = 0

PC_IGrid_H = 5
PC_IGrid_W = 5

CurrentTheme = {}

ShouldDrawFrame = true
CV_SDF = CreateClientConVar( "pc_shoulddrawframe", 1, true, false )
if (CV_SDF:GetInt() == 0) then ShouldDrawFrame = false end

CV_FRAME = CreateClientConVar( "pc_frameid", 1, true, false )
FrameID = CV_FRAME:GetInt()
FrameTex = surface.GetTextureID( "vgui/pc_screen" .. tostring(FrameID) )
function pc_loadframe( id )
	FrameTex = surface.GetTextureID( "vgui/pc_screen" .. tostring(id) )
end
pc_loadframe(FrameID)

// Some more textures
Texs = {}

// Our current loaded program
C_PRO = {}

// Program Data - Stores data per PC for programs
ProgramData = {}

// Loaded Icons - Stores all icons that have been loaded
LoadedIcons = {}

// Here we will load all our programs
include( "cl_programs.lua" )

// Here we will load all our themes
include( "cl_themes.lua" )

function pc_choosedesktopiconslot()
	for x=1, PC_IGrid_W do
		if (!C_PC.DIcons[x]) then C_PC.DIcons[x] = {} end
		for y=1, PC_IGrid_H do
			if (!C_PC.DIcons[x][y]) then return tostring(x) .. "," .. tostring(y) end
		end
	end
end

function pc_init()
	// Create our basic fonts
	surface.CreateFont( "Tahoma", 14, 400, false, false, "PCText" )
	surface.CreateFont( "Tahoma", 10, 400, false, false, "SmallPCText" )
	
	// Get some textures
	Texs.connect = surface.GetTextureID( "vgui/connect" )
	Texs.disconnect = surface.GetTextureID( "vgui/disconnect" )
	
	// Setup the tabbed window
	DInterface:Setup( w*0.25, h*0.25, w*0.5, h*0.5, "PC Mod", true, false )
	
	// Add a settings tab
	DInterface:AddCategory( "CSettings", "Settings", "", "Settings" )
	DInterface:AddCheckbox( "cbFrame", "CSettings", "Enable Frame", 5, 5, ShouldDrawFrame )
	DInterface:AddSlider( "slFrameID", "CSettings", "FrameID", 5, 30, 100, 25, 1, 3, 0 )
	obj = DInterface:GetObject( "cbFrame", "cb", "CSettings" )
	if (obj) then obj:SetConVar( "pc_shoulddrawframe" ) end
	obj = DInterface:GetObject( "slFrameID", "s", "CSettings" )
	if (obj) then obj:SetConVar( "pc_frameid" ) end
	if (obj) then obj:SetValue( FrameID ) end
	DInterface:AddButton( "btnUpdate", "CSettings", "Update", 5, 75, 100, 20, function ()
		FrameID = CV_FRAME:GetInt()
		pc_loadframe(FrameID)
		pc_rebuildscreen()
	end )
		
	// Finish the tabbed window setup (this also enables adding controls to other stuff)
	DInterface:FinishSetup()
	
	// Setup the computer screen gui
	pc_setupscreen()
end
hook.Add( "Initialize", "PCMod_Initialize", pc_init )

function pc_addtotray( icon )
	local ctrl = vgui.Create( "SysTrayIcon" )
	local slot = #C_PC.SysTray+1
	ctrl:SetParent( DInterface:GetPanel( "Desktop" ) )
	ctrl:SetSize( 20, 20 )
	table.insert( C_PC.SysTray, icon )
end

function pc_takefromtray( icon )
	for k, v in pairs( C_PC.SysTray ) do
		if (v == icon) then
			table.remove( C_PC.SysTray, k )
			return
		end
	end
end

function pc_isontray( icon )
	for k, v in pairs( C_PC.SysTray ) do
		if (v == icon) then
			return true
		end
	end
	return false
end

function pc_cleartray()
	C_PC.SysTray = {}
end

function pc_chat( ply, text)
	// This is called when the player has said something
	
	
	
end
//hook.Add( "PlayerChat", "PCMod_Chat", pc_chat )

function pc_wireaddon( um )
	PCMod.WireEnabled = um:ReadShort()
	if (PCMod.WireEnabled == 0) then	
		Msg("PCMod-> Wire NOT detected!\n")
	else
		Msg("PCMod-> Wire detected!\n")
	end
end
usermessage.Hook( "_haswire", pc_wireaddon )

function pc_draw()
	// Check if we are looking at an entity
	local trace = {}
	trace.start = LocalPlayer():EyePos()
	trace.endpos = trace.start + LocalPlayer():GetAimVector() * 200
	trace.filter = LocalPlayer()
	local tr = util.TraceLine(trace)
	
	// Check if that entity is ours - if so, draw relevant info
	if (tr.Entity) and (!tr.HitWorld) then
		ent = tr.Entity
		if (ent.IsPC) then
			local text = { "Standard PC", StatusToString( ent:GetNWInt("Status") ), ent:GetNWString( "IP" ) }
			if (ent.IsLaptop) then text = { "Laptop", StatusToString( ent:GetNWInt("Status") ), ent:GetNWString( "IP" ) } end
			pc_drawbubble( ScrW()*0.4, ScrH()*0.45, ScrW()*0.2, ScrH()*0.1, text )
		end
		if (ent.IsRouter) then
			local subnet = tostring( ent:GetNWInt( "Subnet" ) )
			local text = { "Network Router", "Subnet: " .. subnet }
			
			if (ent.SatRouter) then text[1] = "Satellite Modem" end
			pc_drawbubble( ScrW()*0.4, ScrH()*0.475, ScrW()*0.2, ScrH()*0.05, text )
		end
		if (ent.IsServer) then
			local on = "Off"
			if (ent:GetNWBool("IsOn")) then on = "On" end
			local text = { "Server", "'" .. ent:GetNWString("Type") .. "'", on, ent:GetNWString("IP") }
			pc_drawbubble( ScrW()*0.4, ScrH()*0.45, ScrW()*0.2, ScrH()*0.1, text )
		end
	end
end
hook.Add( "HUDPaint", "PCMod_HUDPaint", pc_draw )

function StatusToString( status )
	if (status == 0) then return "Off" end
	if (status == 1) then return "Booting" end
	if (status == 2) then return "Login" end
	if (status == 3) then return "On" end
end

function pc_drawbubble( x, y, width, height, text )
	draw.RoundedBox( 6, x, y, width, height, Color( 255, 255, 200, 128 ) )
	local heightperlabel = height/#text
	for i=1,#text do
		ypos = y + ((i-1)*heightperlabel)
		xpos = x + (width * 0.5)
		draw.SimpleText( text[i], "PCText", xpos, ypos, Color( 0, 0, 0, 255 ), 1, 3 )
	end
end

function pc_showoptions()
	DInterface:Show()
end
concommand.Add( "pcmod_show", pc_showoptions )

function pc_hideoptions()
	DInterface:Hide()
end
concommand.Add( "pcmod_hide", pc_hideoptions )

function pc_setstatus( status )
	C_PC.Status = status
end

function pc_setupscreen()
	// Load the screen texture
	ScreenTexID = surface.GetTextureID( "vgui/pc_screen1" )
	
	// Create the host window
	local sw = w * 0.9
	local sh = h * 0.9
	PC_ScreenSizeX = sw
	PC_ScreenSizeY = sh
	DInterface:MakeWindow( "host", "PCMod V1.0" .. PCMod.Version .. " - by [GU]|ZLC|thomasfn", (w-sw)/2, (h-sh)/2, sw, sh, false, false )
	DInterface:MakePanel( "pcscreen", WTC("host"), 0, 0, sw, sh, function( self )
		if (ShouldDrawFrame) then
			surface.SetTexture( FrameTex )
			surface.SetDrawColor( 255, 255, 255, 255 )
			surface.DrawTexturedRect( 0, 0, self:GetWide(), self:GetTall() )
		end
	end )
	
	// Create the 'desktop'
	local ss = pc_calcscreensize( sw, sh )
	local dw = ss[1]
	local dh = ss[2]
	local dx = ss[3]
	local dy = ss[4]
	
	DInterface:MakePanel( "desktop", PTC("pcscreen"), dx, dy, dw, dh, pc_paintdesktop )
		DInterface:AddButton( "turnon", PTC("pcscreen"), "Turn On", 5, sh-60, 100, 20, function() pc_command( "turn_on" ); end )
		DInterface:AddButton( "turnoff", PTC("pcscreen"), "Turn Off", 110, sh-60, 100, 20, function() pc_command( "turn_off" ); end )
		DInterface:AddButton( "closescreen", PTC("pcscreen"), "Close", 215, sh-60, 100, 20, function() pc_closescreen(); end )
		
	// Create the window in which programs will run
	DInterface:MakePanel( "window", PTC("desktop"), 5, 5, dw-10, dh-30, pc_paintwindow )
	
	// Create the system tray
	local desktop = DInterface:GetPanel( "desktop" )
	
	C_PC.SysTray[1] = vgui.Create( "SysTrayIcon" )
	C_PC.SysTray[1]:SetParent( desktop )
	C_PC.SysTray[1]:SetIcon( "vgui/connect" )
	C_PC.SysTray[1]:SetPos( desktop:GetWide()-20, desktop:GetTall()-20 )
	C_PC.SysTray[1].Show = false
	
	C_PC.SysTray[2] = vgui.Create( "SysTrayIcon" )
	C_PC.SysTray[2]:SetParent( desktop )
	C_PC.SysTray[2]:SetIcon( "vgui/transmit" )
	C_PC.SysTray[2]:SetPos( desktop:GetWide()-40, desktop:GetTall()-20 )
	C_PC.SysTray[2].Show = false
	
	// Create the start menu
	PCMod.StartMenu = vgui.Create( "StartMenu" )
	PCMod.StartMenu:SetParent( desktop )
	PCMod.StartMenu:SetPos( 0, desktop:GetTall()*0.25 )
	PCMod.StartMenu:SetSize( desktop:GetWide()*0.25, (desktop:GetTall()*0.75) - 20 )
	PCMod.StartMenu:Setup()
	PCMod.StartMenu:SetV( false )
	
	// Create the programs list
	PCMod.ProgramList = vgui.Create( "ProgramList" )
	PCMod.ProgramList:SetParent( desktop )
	PCMod.ProgramList.ParentHeight = desktop:GetTall()
	PCMod.ProgramList:SetPos( desktop:GetWide()*0.25, 0 )
	PCMod.ProgramList:SetWidth( desktop:GetWide()*0.2 )
	PCMod.ProgramList:SetV( false )
end

function pc_geticon( icon )
	if (!LoadedIcons[icon]) then
		LoadedIcons[icon] = surface.GetTextureID( icon )
	end
	return LoadedIcons[icon]
end

function pc_paintdesktop( self )
	local status = C_PC.Status
	if (status == 0) then
		// PC is Off
		surface.SetDrawColor( 0, 0, 0, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), self:GetTall() )
		draw.SimpleText( "< PC OFF >", "PCText", self:GetWide()/2, self:GetTall()/2, Color(255, 255, 255, 255), 1, 1 )
	end
	if (status == 1) then
		// PC is Booting
		surface.SetDrawColor( 0, 0, 50, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), self:GetTall() )
		draw.SimpleText( "Booting PC...", "PCText", self:GetWide()/2, self:GetTall()/2, Color(255, 255, 255, 255), 1, 1 )
	end
	if (status == 2) then
		// PC is requesting password
		surface.SetDrawColor( 128, 128, 255, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), self:GetTall() )
		surface.SetDrawColor( 50, 50, 50, 128 )
		surface.DrawRect( 0, 0, self:GetWide(), 20 )
		draw.SimpleText( "Please enter your password to login.", "PCText", self:GetWide()/2, 10, Color(255, 255, 255, 255), 1, 1 )
		
		local txtPass = DInterface:GetObject( "txtPass", "tb", PTC("desktop") )
		local btnGo = DInterface:GetObject( "btnGo", "b", PTC("desktop") )
		if (!txtPass) then DInterface:AddTextbox( "txtPass", PTC("desktop"), "", (self:GetWide()*0.25), (self:GetTall()*0.42), (self:GetWide()*0.5), (self:GetTall()*0.08) ) end
		if (!btnGo) then DInterface:AddButton( "btnGo", PTC("desktop"), "Login", (self:GetWide()*0.25), (self:GetTall()*0.5), (self:GetWide()*0.5), (self:GetTall()*0.08), function()
			pass = DInterface:GetTextboxValue( "txtPass", PTC("desktop") )
			RunConsoleCommand( "pc_command", "enter_password", pass )
		end ) end
		
		btnGo = DInterface:GetObject( "btnGo", "b", PTC("desktop") )
		if (btnGo) then pc_hackbutton( btnGo ) end
	end
	if (status == 3) then
		// PC is On
		local btnStart = DInterface:GetObject( "btnStart", "b", PTC("desktop") )
		if (!btnStart) then DInterface:AddButton( "btnStart", PTC("desktop"), "Start", 0, self:GetTall()-20, 40, 20, function()
		
			PCMod.StartMenu:SetV( true )
		
			/*
			// Create the menu
			local PMenu = DermaMenu()
			PMenu:SetParent( DInterface:GetPanel( "Desktop" ) )
			
			// Add the options, set their image and 'hack' them
			// My Computer
			PMenu:AddOption( "My Computer", function( self ) RunConsoleCommand( "pc_command", "load_prog", "MyComputer" ); end )
			pc_hackmenuoption( PMenu.Panels[ #PMenu.Panels ] )
			PMenu.Panels[ #PMenu.Panels ].Image = pc_geticon( "gui/silkicons/application_xp_terminal" )
			
			// Shut Down
			PMenu:AddOption( "Shut Down", function( self ) pc_command( "turn_off" ); end )
			pc_hackmenuoption( PMenu.Panels[ #PMenu.Panels ] )
			PMenu.Panels[ #PMenu.Panels ].Image = pc_geticon( "gui/silkicons/error" )
			
			// Reboot
			PMenu:AddOption( "Reboot", function( self ) pc_command( "turn_off" ); pc_command( "turn_on" ); end )
			pc_hackmenuoption( PMenu.Panels[ #PMenu.Panels ] )
			
			// Log Off
			PMenu:AddOption( "Log Off", function( self ) pc_command( "log_off" ); end )
			pc_hackmenuoption( PMenu.Panels[ #PMenu.Panels ] )
			PMenu.Panels[ #PMenu.Panels ].Image = pc_geticon( "gui/silkicons/exclamation" )
			
			// All Programs
			PMenu:AddSpacer()
			local ProMenu = PMenu:AddSubMenu( "All Programs" )
			for i=1, #C_PC.PList do
				// Get the program name
				pname = C_PC.PList[i]
				if (pname != "MyComputer") then
					// Add the option and 'hack' it
					ProMenu:AddOption( pname, function( self ) RunConsoleCommand( "pc_command", "load_prog", self.pname ); end )
					local item = ProMenu.Panels[ #ProMenu.Panels ]
					pc_hackmenuoption( item )
					
					// Set the item name
					item.pname = pname
					
					// If theres an icon, load it
					if ((ProgramList[ pname ]) && (ProgramList[ pname ].Icon)) then
						item.Image = pc_geticon( "gui/silkicons/" .. ProgramList[ pname ].Icon )
					end
				end
			end
			PMenu:Open()
			*/
		end )
			btnStart = DInterface:GetObject( "btnStart", "b", PTC("desktop") )
			pc_hackbutton( btnStart )
		end
	
		// Get the Desktop Colour
		local r = CurrentPC:GetNWInt("OS_DesktopR")
		local g = CurrentPC:GetNWInt("OS_DesktopG")
		local b = CurrentPC:GetNWInt("OS_DesktopB")
		if (!r) then r = 128 end
		if (!g) then g = 128 end
		if (!b) then b = 255 end
		
		// Draw the desktop background
		surface.SetDrawColor( r, g, b, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), self:GetTall() )
		
		// Draw the lower bar
		CurrentTheme:DrawLowerBar( 0, self:GetTall()-20, self:GetWide(), 20 )
		
		// Update the system tray
		C_PC.SysTray[1].Show = true
			if (C_PC.Online) then
				C_PC.SysTray[1]:SetIcon( "vgui/connect" )
			else
				C_PC.SysTray[1]:SetIcon( "vgui/disconnect" )
			end
		C_PC.SysTray[2].Show = CurrentPC:GetNWBool( "wireless" )
		
		// Draw the upper bar
		//surface.DrawRect( 0, self:GetTall()-20, self:GetWide(), 20 )
		//draw.SimpleText( "PCMod GMOD OS Version 1-" .. PCMod.Version, "PCText", self:GetWide()/2, 10, Color(255, 255, 255, 255), 1, 1 )
		
		// Draw the network status
		//if (C_PC.Online) then OnlineText = "Connected"; else OnlineText = "Unconnected"; end
		//OnlineText = OnlineText .. " - " .. C_PC.IP
		//draw.SimpleText( "Network Status: " .. OnlineText, "PCText", self:GetWide()/2, self:GetTall()-10, Color(255, 255, 255, 255), 1, 1 )
		
		// Draw the wireless stuff
		//if (CurrentPC:GetNWBool( "wireless" )) then
			//draw.SimpleText( "Wireless", "PCText", 2, 2, Color( 255, 255, 255, 255 ), TEXT_ALIGN_LEFT, TEXT_ALIGN_TOP )
		//end
	end
end

function pc_hackmenuoption( control )
	// Hack the menu option by adding our own functions to it, or overriding existing ones
	// (Code 'borrowed' from ASSMod :P)
	if (!control) then return end
	control.Paint = function( self )
		derma.SkinHook( "Paint", "MenuOption", self )
		
		if (self.Image) then
	 		surface.SetTexture( self.Image ) 
 			surface.SetDrawColor( 255, 255, 255, 255 ) 
 			surface.DrawTexturedRect( 2, (self:GetTall() - 16) * 0.5, 16, 16)
 		end
	end
end

function pc_hackbutton( control )
	// Hack the button by overriding the paint function
	if (!control) then return end
	control.Paint = function( self )
		CurrentTheme:DrawButton( 0, 0, self:GetWide(), self:GetTall(), self:IsDown() )
	end
end

function pc_paintwindow( self )
	if (!C_PRO) then C_PRO = {} end
	if (C_PRO.Exists) then
		// We have a program up and running
		// Draw the background
		CurrentTheme:DrawBackground( 0, 0, self:GetWide(), self:GetTall() )
		
		// Draw the title bar
		local txt = C_PRO.NiceName .. " - " .. C_PRO.Author
		CurrentTheme:DrawProgramBar( 0, 0, self:GetWide(), 20, txt )
	end
end

function PrintCurrentPC()
	Msg( tostring(CurrentPCIndex) )
	// Debug command
end
concommand.Add( "pc_current", PrintCurrentPC )

// Sends a command from the client program to the server program
function SendCommand( command, ... )
	RunConsoleCommand( "pc_command", "prog_command", command, ... )
end

function pc_openscreen( um )
	if (!C_PRO) then C_PRO = {} end
	
	// We must assume we are opening a different PC up, so we must reset our current one
	if (C_PRO.Exists) then pc_progunload() end
	
	// Ensure the start menu is unloaded
	PCMod.StartMenu:SetV( false )
	PCMod.ProgramList:SetV( false )
	
	// Called when server tells client to open a computer screen (on pcmod_pc:Use)
	DInterface:ShowWindow( "host" )
	CurrentPCIndex = um:ReadShort()
	CurrentProgram = um:ReadString()
	CurrentWindow = um:ReadString()
	CurrentTheme = ThemeList[ um:ReadString() ]
	if (!CurrentTheme) then CurrentTheme = {} end
	CurrentPC = ents.GetByIndex( CurrentPCIndex )
	
	//gui.EnableScreenClicker( true )
	
	if (CurrentProgram != "") then
		C_PRO = ProgramList[ CurrentProgram ]
		if (!C_PRO) then
			Msg( "Warning: Could not find program '" .. CurrentProgram .. "'! (No C_PRO)\n" )
		else
			if (C_PRO.Exists) then
				C_PRO:ClearWindow( PTC("window") )
				C_PRO:BuildWindow( CurrentWindow, PTC("window"), DInterface["d_prop_l" .. PTC("window")] )
				local quit = DInterface:GetObject( "btnQuit", "b", PTC("window") )
				//if (quit) then pc_hackbutton( quit ) end
			else
				Msg( "Warning: Could not find program '" .. CurrentProgram .. "'! (No C_PRO.Exists)\n" )
			end
		end
	end
	
	// Delete the password stuff if it exists
	local txtPass = DInterface:GetObject( "txtPass", "tb", PTC("desktop") )
	local btnGo = DInterface:GetObject( "btnGo", "b", PTC("desktop") )
	if (txtPass) then DInterface:RemoveTextbox( "txtPass", PTC("desktop") ) end
	if (btnGo) then DInterface:RemoveButton( "btnGo", PTC("desktop") ) end
	
	// Set a global
	PCLoaded = true
end
usermessage.Hook( "_pcmod_openscreen", pc_openscreen )

function pc_refresh()
	if (!C_PRO) then C_PRO = {} end
	if (!CurrentPC) or (CurrentPCIndex == 0) then return end
	C_PC.Status = CurrentPC:GetNWInt("Status")
	C_PC.Online = CurrentPC:GetNWBool("Online")
	C_PC.IP = CurrentPC:GetNWString("IP")
	if (C_PC.Status != 2) then
		local txtPass = DInterface:GetObject( "txtPass", "tb", PTC("desktop") )
		local btnGo = DInterface:GetObject( "btnGo", "b", PTC("desktop") )
		if (txtPass) then DInterface:RemoveTextbox( "txtPass", PTC("desktop") ) end
		if (btnGo) then DInterface:RemoveButton( "btnGo", PTC("desktop") ) end
	end
	if (C_PC.Status != 3) then
		local btnGo = DInterface:GetObject( "btnStart", "b", PTC("desktop") )
		if (btnGo) then DInterface:RemoveButton( "btnStart", PTC("desktop") ) end
		if (C_PRO.Exists) then pc_progunload() end
	end
end
hook.Add( "Think", "PCMod_Think", pc_refresh )

function pc_closescreen()
	DInterface:HideWindow( "host" )
	PCLoaded = false
	//gui.EnableScreenClicker( false )
end

function pc_command( command )
	RunConsoleCommand( "pc_command", command )
end

function pc_progload( um )
	if (!C_PRO) then C_PRO = {} end
	if (C_PRO.Exists) then
		C_PRO:DestroyWindow()
	end
	progname = um:ReadString()
	C_PRO = ProgramList[ progname ]
end
usermessage.Hook( "_pcmod_runprog", pc_progload )

function pc_progunload( )
	if (!C_PRO) then C_PRO = {} end
	if (C_PRO.Exists) then C_PRO:ClearWindow( PTC("window") ) end
	C_PRO = {}
end
usermessage.Hook( "_pcmod_killprog", pc_progunload )

function pc_progwindow( um )
	if (!C_PRO) then C_PRO = {} end
	if (!C_PRO.Exists) then return end
	winname = um:ReadString()
	C_PRO:ClearWindow( PTC("window") )
	C_PRO:BuildWindow( winname, PTC("window"), DInterface["d_prop_l" .. PTC("window")] )
end
usermessage.Hook( "_pcmod_progwindow", pc_progwindow )

function pc_themeupdate( um )
	local th = um:ReadString()
	CurrentTheme = ThemeList[ th ]
	if (!CurrentTheme) then CurrentTheme = ThemeList[ "DefaultBlue" ] end
end
usermessage.Hook( "_pcmod_themeupdate", pc_themeupdate )

function pc_beamlist( um )
	if (!C_PC) then return end
	C_PC.PList = {}
	cnt = um:ReadShort()
	for i=1,cnt do
		C_PC.PList[i] = um:ReadString()
	end
end
usermessage.Hook( "_pcmod_beamlist", pc_beamlist )

function pc_beamdata_str( um )
	if (!C_PRO) then C_PRO = {} end
	if (!C_PRO.Exists) then return end
	C_PRO:DataRecieved( PTC("window"), { um:ReadString(), um:ReadString() } )
end
usermessage.Hook( "_pcmod_beamdata_str", pc_beamdata_str )

function pc_beamdata_int( um )
	if (!C_PRO) then C_PRO = {} end
	if (!C_PRO.Exists) then return end
	C_PRO:DataRecieved( PTC("window"), { um:ReadString(), um:ReadShort() } )
end
usermessage.Hook( "_pcmod_beamdata_int", pc_beamdata_int )

function pc_beamdata_float( um )
	if (!C_PRO) then C_PRO = {} end
	if (!C_PRO.Exists) then return end
	C_PRO:DataRecieved( PTC("window"), { um:ReadString(), um:ReadFloat() } )
end
usermessage.Hook( "_pcmod_beamdata_float", pc_beamdata_float )

function pc_calcscreensize(hw, hh)
	local dw = (hw * 0.75)
	local dh = (hh * 0.7)
	local dx = (hw * 0.125)
	local dy = (hh * 0.125)
	if (!ShouldDrawFrame) then
		dw = (hw * 0.94)
		dh = (hh * 0.85)
		dx = (hw * 0.02)
		dy = (hh * 0.02)
	end
	return {dw, dh, dx, dy}
end

function pc_rebuildscreensize(hw, hh)
	obj = DInterface:GetPanel( "desktop" )
	if (!obj) then return end
	ss = pc_calcscreensize( hw, hh )
	local dw = ss[1]
	local dh = ss[2]
	local dx = ss[3]
	local dy = ss[4]
	obj:SetSize(dw, dh)
	obj:SetPos(dx, dy)
	obj = DInterface:GetPanel( "window" )
	if (!obj) then return end
	obj:SetSize(dw-10, dh-50)
	pc_progunload()
end

function pc_rebuildscreen()
	ShouldDrawFrame = true
	if (CV_SDF:GetInt() == 0) then ShouldDrawFrame = false end
	pc_rebuildscreensize( PC_ScreenSizeX, PC_ScreenSizeY )
end
concommand.Add( "pc_rebuildscreen", pc_rebuildscreen )

// These functions set and get networked OS vars
function SetOSVar( pc, VarName, VarValue )
	local tp = type( VarValue )
	local vn = "OS_" .. VarName
	if (!VarValue) then return end
	if (tp == "boolean") then pc:SetNWBool( vn, VarValue ) end
	if (tp == "string") then pc:SetNWString( vn, VarValue ) end
	if (tp == "number") then pc:SetNWInt( vn, VarValue ) end
end
function GetOSVar( pc, VarType, VarName )
	local vn = "OS_" .. VarName
	if (tp == "boolean") then return pc:GetNWBool( vn ) end
	if (tp == "string") then return pc:GetNWString( vn ) end
	if (tp == "number") then return pc:GetNWInt( vn ) end
end

// System Tray Icon
PANEL = {}
function PANEL:SetIcon( icon )
	self.Icon = pc_geticon( icon )
	self:SetWide( 20 )
	self:SetTall( 20 )
	self.Show = true
end
function PANEL:Paint()
	if ((self.Show) && (C_PC.Status==3)) then
		surface.SetTexture( self.Icon )
		surface.SetDrawColor( 255, 255, 255, 255 )
		surface.DrawTexturedRect( 0, 0, self:GetWide(), self:GetTall() )
	end
end
vgui.Register( "SysTrayIcon", PANEL, "PANEL" )

// Start Menu
PANEL = {}
function PANEL:Setup()
	self.btnQuit = vgui.Create( "DButton" )
	self.btnQuit:SetParent( self )
	self.btnQuit:SetPos( self:GetWide()-20, 0 )
	self.btnQuit:SetSize( 20, 20 )
	self.btnQuit:SetText( "X" )
	self.btnQuit.DoClick = function( self )
		PCMod.StartMenu:SetV( false )
		PCMod.ProgramList:SetV( false )
	end
	pc_hackbutton( self.btnQuit )
	
	self.btnMyComputer = vgui.Create( "DButton" )
	self.btnMyComputer:SetParent( self )
	self.btnMyComputer:SetPos( 6, (self:GetTall()*0.1) + 12 )
	self.btnMyComputer:SetSize( self:GetWide()-12, 25 )
	self.btnMyComputer:SetText( "My Computer" )	
	self.btnMyComputer.DoClick = function( self )
		PCMod.StartMenu:SetV( false )
		RunConsoleCommand( "pc_command", "load_prog", "MyComputer" )
	end
	
	self.btnShutDown = vgui.Create( "DButton" )
	self.btnShutDown:SetParent( self )
	self.btnShutDown:SetPos( 6, (self:GetTall()*0.1) + 52 )
	self.btnShutDown:SetSize( self:GetWide()-12, 25 )
	self.btnShutDown:SetText( "Shut Down" )	
	self.btnShutDown.DoClick = function( self )
		PCMod.StartMenu:SetV( false )
		RunConsoleCommand( "pc_command", "turn_off" )
	end
	
	self.btnLogOff = vgui.Create( "DButton" )
	self.btnLogOff:SetParent( self )
	self.btnLogOff:SetPos( 6, (self:GetTall()*0.1) + 82 )
	self.btnLogOff:SetSize( self:GetWide()-12, 25 )
	self.btnLogOff:SetText( "Log Off" )	
	self.btnLogOff.DoClick = function( self )
		PCMod.StartMenu:SetV( false )
		RunConsoleCommand( "pc_command", "log_off" )
	end
	
	self.btnAllProgs = vgui.Create( "DButton" )
	self.btnAllProgs:SetParent( self )
	self.btnAllProgs:SetPos( 6, self:GetTall() - 30 )
	self.btnAllProgs:SetSize( self:GetWide()-12, 25 )
	self.btnAllProgs:SetText( "All Programs" )
	self.btnAllProgs.DoClick = function( )
		PCMod.ProgramList:SetV( true )
		PCMod.ProgramList:BuildList( )
	end
	
	pc_hackbutton( self.btnMyComputer )
	pc_hackbutton( self.btnShutDown )
	pc_hackbutton( self.btnLogOff )
	pc_hackbutton( self.btnAllProgs )
end
function PANEL:SetV( v )
	self.Show = v
	self:SetVisible( v )
end
function PANEL:Paint()
	if ((self.Show) && (C_PC.Status==3)) then
		local pri = CurrentTheme.StartMenu.MainColour
		local sec = CurrentTheme.StartMenu.SecondaryColour
		local tex = CurrentTheme.StartMenu.TextColour
		draw.RoundedBox( 6, 0, 0, self:GetWide(), self:GetTall(), sec )
		draw.RoundedBox( 6, 4, 4, self:GetWide()-8, self:GetTall()*0.1, pri )
		draw.RoundedBox( 6, 4, (self:GetTall()*0.1)+8, self:GetWide()-8, (self:GetTall()*0.9)-12, pri )
		draw.SimpleText( "Start Menu", "PCText", self:GetWide()/2, self:GetTall()*0.05, tex, 1, 1 )
	end
end
vgui.Register( "StartMenu", PANEL, "PANEL" )

// Program List
PANEL = {}
PANEL.PButtons = {}
function PANEL:BuildList()
	// Remove all existing buttons
	for k, v in pairs( self.PButtons ) do
		if (v) then v:Remove() end
	end
	self.PButtons = {}
	
	// Get the program list
	local ps = C_PC.PList
	
	// Set our dimensions and position
	self:SetTall( #ps*20 )
	local x, y = self:GetPos()
	self:SetPos( x, self.ParentHeight - ((#ps+1)*20) )
	
	// Cycle through all the programs
	local cnt = 0
	for k, v in pairs( ps ) do
		// Get the program
		local prog = ProgramList[ v ]
		
		// Check the program is valid
		if (prog) then
			// Get our Y position
			cnt = cnt + 1
			local y = (k-1)*20
			
			// Build the button
			local btn = vgui.Create( "DButton" )
			btn:SetParent( self )
			btn:SetPos( 1, y )
			btn:SetSize( self:GetWide(), 18 )
			btn:SetText( "" )
			//btn:SetTextColor( Color( 0, 0, 0, 255 ) )
			btn.DoClick = function( self )
				RunConsoleCommand( "pc_command", "load_prog", self.PName )
				PCMod.StartMenu:SetV( false )
				PCMod.ProgramList:SetV( false )
			end
			btn.PName = prog.PName
			btn.NName = prog.NiceName
			
			btn.Paint = function( self )
				CurrentTheme:DrawProgramButton( 0, 0, self:GetWide(), self:GetTall(), self.Hovered, self.Depressed, self.NName )
				
			end
			
			// Store the button
			self.PButtons[k] = btn
		end
	end
end
function PANEL:SetV( v )
	self.Show = v
	self:SetVisible( v )
end
//function PANEL:Paint()
	//if ((self.Show) && (C_PC.Status==3)) then
		
	//end
//end
function PANEL:Think()
	if (PCMod.StartMenu.Show == false) then self:SetV( false ) end
end
vgui.Register( "ProgramList", PANEL, "PANEL" )

Msg( "== PCMod Clientside OS Loaded ==\n" )