
TOOL.Category		= "PC Mod - Hardware"
TOOL.Name			= "#Standard PC"
TOOL.Command		= nil
TOOL.ConfigName		= ""

TOOL.ClientConVar[ "weld" ] = 1
TOOL.ClientConVar[ "password" ] = ""
TOOL.ClientConVar[ "model" ] = "props/cs_office/computer_monitor.mdl"

cleanup.Register( "computers" )

if (CLIENT) then
	language.Add( 'Tool_pc_name', 'PC Spawner' )
	language.Add( 'Tool_pc_desc', 'Create PCs for use with a PC network' )
	language.Add( 'Tool_pc_0', 'Left-Click: Spawn a PC.' )
	
	language.Add( 'Undone_PC', 'PC Undone' )
	language.Add( 'Cleanup_computers', 'Computers' )
	language.Add( 'Cleaned_computers', 'Cleaned up all computers' )
end

function TOOL:LeftClick( trace )

	// If the target is a player, stop here.
	if ( trace.Entity && trace.Entity:IsPlayer() ) then return false end
	
	// The rest of the function is server-only stuff.
	if (CLIENT) then return true end
	
	// Get some variables
	local ply = self:GetOwner()
	local weld = ( self:GetClientNumber( "weld" ) == 1 )
	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	local Pos = trace.HitPos
	local model = self:GetClientInfo( "model" )

	// Make the entity
	local ent = MakePC( ply, Ang, Pos )
	local const
	
	// If the entity does not exist, end here
	if (!ent) then return false end
	
	ent.Password = self:GetClientInfo( "password" )
	ent:ChangeModel( model )
	
	// With thanks to WireMod team :P
	local min = ent:OBBMins()
	ent:SetPos( trace.HitPos - trace.HitNormal * min.z )
	
	// Only weld if we want to
	if ( weld ) and ( trace.Entity ) and (!trace.HitWorld) then
		const = constraint.Weld( ent, trace.Entity, 0, trace.PhysicsBone, 0, collision == 0, true )
	end
	
	// Add this to the undo list
	undo.Create("PC")
		undo.AddEntity( ent )
		undo.AddEntity( const )
		undo.SetPlayer( ply )
	undo.Finish()
	
	// Add this to the cleanup list
	ply:AddCleanup( "computers", ent )
	ply:AddCleanup( "computers", const )
	
	// This was successful!
	return true
end

if (SERVER) then

	function MakePC( pl, Ang, Pos )
	
		// Create the entity and stop here if it isn't valid
		local pc = ents.Create( "pcmod_pc" )
		if (!pc:IsValid()) then return false end

		// Set it's angles and position, and spawn it
		pc:SetAngles( Ang )
		pc:SetPos( Pos )
		pc:Spawn()

		// Add it to the counter
		pl:AddCount( "computers", pc )
		
		// Make the effect
		DoPropSpawnedEffect( pc )

		// Return the entity
		return pc
		
	end

end

function TOOL:UpdateGhost( ent, player )

	if ( !ent || !ent:IsValid() ) then return end

	local tr 	= utilx.GetPlayerTrace( player, player:GetCursorAimVector() )
	local trace 	= util.TraceLine( tr )
	
	if (!trace.Hit || trace.Entity:IsPlayer() || trace.Entity:GetClass() == "pcmod_pc" ) then
		ent:SetNoDraw( true )
		return
	end
	
	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	ent:SetAngles( Ang )	

	local min = ent:OBBMins()
	ent:SetPos( trace.HitPos - trace.HitNormal * min.z )
	
	ent:SetNoDraw( false )

end

function TOOL:Think()
	if (!self.GhostEntity || !self.GhostEntity:IsValid() || self.GhostEntity:GetModel() != self:GetClientInfo( "model" )) then
		self:MakeGhostEntity( self:GetClientInfo( "model" ), Vector(0,0,0), Angle(0,0,0) )
	end
	
	self:UpdateGhost( self.GhostEntity, self:GetOwner() )
end

function TOOL.BuildCPanel( CPanel )

	list.Set( "pcmod_pc", "models/props/cs_office/computer_monitor.mdl", {} )
	list.Set( "pcmod_pc", "models/props_lab/monitor01a.mdl", {} )
	list.Set( "pcmod_pc", "models/props_lab/monitor01b.mdl", {} ) -- Untested (Probably too small)
	//list.Set( "pcmod_pc", "models/props_lab/monitor02.mdl", {} ) -- Ugly 2D 3D
	list.Set( "pcmod_pc", "models/props_c17/tv_monitor01.mdl", {} ) -- Untested (Probably too small)
	list.Set( "pcmod_pc", "models/props/cs_office/TV_plasma.mdl", {} )

	if (PCMod.WireEnabled != 0) then
		//list.Set( "pcmod_pc", "models/blacknecro/tv_plasma_4_3.mdl", {} )
		//list.Set( "pcmod_pc", "models/kobilica/wiremonitorsmall.mdl", {} )
		//list.Set( "pcmod_pc", "models/kobilica/wiremonitorbig.mdl", {} )
	end
 
    CPanel:AddControl( "Header", { Text = "#Tool_pc_name", Description  = "#Tool_pc_desc" }  )
 
    CPanel:AddControl( "CheckBox", { Label = "#Weld",
                                     Command = "pc_weld" } )
                                     
    CPanel:AddControl( "Textbox", { Label = "Password:",
                                    MaxLength = 16,
                                    Command = "pc_password" } )
                                    
    CPanel:AddControl( "PropSelect", { Label = "Model:",
                                    ConVar = "pc_model",
                                    Category = "pcmod",
                                    Models = list.Get( "pcmod_pc" ) } )       
end