
TOOL.Category		= "PC Mod - Wiring"
TOOL.Name			= "#PC Linker"
TOOL.Command		= nil
TOOL.ConfigName		= ""

cleanup.Register( "computers" )

if (CLIENT) then

	language.Add( 'Tool_pclinker_name', 'PC Linker' )
	language.Add( 'Tool_pclinker_desc', 'Connects PCs to a router' )
	language.Add( 'Tool_pclinker_0', 'Left-Click: Select a PC to connect. Right-Click: Unconnect a PC.' )
	language.Add( 'Tool_pclinker_1', 'Left-Click: Select a router to connect to. ' )

end

function TOOL:LeftClick( trace )

	// If the target is a player, stop here.
	if ( trace.Entity && trace.Entity:IsPlayer() ) then return false end
	
	// If there is no physics object, stop here.
	if ( SERVER && !util.IsValidPhysicsObject( trace.Entity, trace.PhysicsBone ) ) then return false end
	
	// Clients can stop here
	local iNum = self:NumObjects()
	if ( CLIENT ) then
		if ( iNum > 0 ) then self:ClearObjects() end
		return true
	end
	
	// Get the player
	local ply = self:GetOwner()
	
	// Get our object
	local Phys = trace.Entity:GetPhysicsObjectNum( trace.PhysicsBone )
	local id = trace.Entity:EntIndex()
	if (iNum == 0) then
		if (!trace.Entity.IsPC) then
			ply:PrintMessage( HUD_PRINTTALK, "That entity is not a PC!" )
			return false
		end
		if (trace.Entity.Data[id].Router) then
			ply:PrintMessage( HUD_PRINTTALK, "That PC is already linked" )
			return false
		end
		if ((trace.Entity.IsLaptop) && (trace.Entity.Wireless)) then
			ply:PrintMessage( HUD_PRINTTALK, "That PC is wireless!" )
			return false
		end
	end
	if (iNum == 1) then
		if (!trace.Entity.IsRouter) then
			ply:PrintMessage( HUD_PRINTTALK, "That entity is not a router!" )
			return false
		end
	end
	self:SetObject( iNum + 1, trace.Entity, trace.HitPos, Phys, trace.PhysicsBone, trace.HitNormal )

	if ( iNum > 0 ) then

		// Setup our variables
		local forcelimit = 0
		local addlength	 = 100
		local material 	 = "cable/cable2"
		local width 	 = 2
		local rigid	 	= false
		
		// Get information we're about to use
		local Ent1,  Ent2  = self:GetEnt(1),	 self:GetEnt(2)
		local Bone1, Bone2 = self:GetBone(1),	 self:GetBone(2)
		local WPos1, WPos2 = self:GetPos(1),	 self:GetPos(2)
		local LPos1, LPos2 = self:GetLocalPos(1),self:GetLocalPos(2)
		local length = ( WPos1 - WPos2):Length()

		// Create the rope
		local const, rope = constraint.Rope( Ent1, Ent2, Bone1, Bone2, LPos1, LPos2, length+addlength, 0, forcelimit, width, material, rigid )
		
		// Tell the PC that the router is linked
		Ent1.Data[Ent1:EntIndex()].Router = Ent2
		Ent1.const = const
		Ent1.rope = rope
		
		
		// Clear the objects so we're ready to go again
		self:ClearObjects()
	else
		// Advance our stage
		self:SetStage( iNum+1 )
	end
	
	// This was successful!
	return true
end

function TOOL:RightClick( trace )
	
	// If the target is a player, stop here.
	if ( trace.Entity && trace.Entity:IsPlayer() ) then return false end
	
	// Clients stop here.
	if ( CLIENT ) then return true end
	
	// If there is no physics object, stop here.
	if ( SERVER && !util.IsValidPhysicsObject( trace.Entity, trace.PhysicsBone ) ) then return false end
	
	// Get the player
	local ply = self:GetOwner()
	
	// Get our object
	local Phys = trace.Entity:GetPhysicsObjectNum( trace.PhysicsBone )
	local id = trace.Entity:EntIndex()
	
	// Check the object
	if (!trace.Entity.IsPC) then
		ply:PrintMessage( HUD_PRINTTALK, "That entity is not a PC!" )
		return false
	end
	if (!trace.Entity.Data[id].Router) then
		ply:PrintMessage( HUD_PRINTTALK, "That PC is not linked!" )
		return false
	end
	
	// Unlink the PC
	trace.Entity.Data[id].Router = nil
	if (trace.Entity.rope) then trace.Entity.rope:Remove() end
	if (trace.Entity.const) then trace.Entity.const:Remove() end
	
	// This was successful!
	return true
end

function TOOL.BuildCPanel( CPanel )

	// HEADER
	CPanel:AddControl( "Header", { Text = "#Tool_pc_name", Description	= "#Tool_pc_desc" }  )

end