
TOOL.Category		= "PC Mod - Hardware"
TOOL.Name			= "#Satellite Modem"
TOOL.Command		= nil
TOOL.ConfigName		= ""

TOOL.ClientConVar[ "weld" ] = 1
TOOL.ClientConVar[ "password" ] = ""
TOOL.ClientConVar[ "model" ] = "models/props_lab/reciever01b.mdl"

cleanup.Register( "computers" )

if (CLIENT) then
	language.Add( 'Tool_satrouter_name', 'Satellite Modem Spawner' )
	language.Add( 'Tool_satrouter_desc', 'Create satellite modems for use with a PC network' )
	language.Add( 'Tool_satrouter_0', 'Left-Click: Spawn a modem.' )
	
	language.Add( 'Undone_Router', 'Router Undone' )
	language.Add( 'Cleanup_Router', 'Router' )
	language.Add( 'Cleaned_Router', 'Cleaned up all routers' )	
end

function TOOL:LeftClick( trace )

	// If the target is a player, stop here.
	if ( trace.Entity && trace.Entity:IsPlayer() ) then return false end
	
	// The rest of the function is server-only stuff.
	if (CLIENT) then return true end
	
	// Get some variables
	local ply = self:GetOwner()
	local weld = ( self:GetClientNumber( "weld" ) == 1 )
	local pass = ( self:GetClientInfo( "password" ) )
	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	local Pos = trace.HitPos

	// Make the entity
	local ent = MakeSatRouter( ply, Ang, Pos )
	local const
	
	// If the entity does not exist, end here
	if (!ent) then return false end
	
	// Only weld if we want to
	if ( weld ) and ( trace.Entity ) and (!trace.HitWorld) then
		const = constraint.Weld( ent, trace.Entity, 0, trace.PhysicsBone, 0, collision == 0, true )
	end
	
	// With thanks to WireMod team :P
	local min = ent:OBBMins()
	ent:SetPos( trace.HitPos - trace.HitNormal * min.z )
	
	// Set some more vars
	if ( pass ) then ent.Password = pass end
	
	// Add this to the undo list
	undo.Create("Router")
		undo.AddEntity( ent )
		undo.AddEntity( const )
		undo.SetPlayer( ply )
	undo.Finish()
	
	// Add this to the cleanup list
	ply:AddCleanup( "computers", ent )
	ply:AddCleanup( "computers", const )
	
	// This was successful!
	return true
end

if (SERVER) then

	function MakeSatRouter( pl, Ang, Pos )
	
		// Create the entity and stop here if it isn't valid
		local router = ents.Create( "pcmod_router" )
		if (!router:IsValid()) then return false end

		// Set it's angles and position, and spawn it
		router:SetAngles( Ang )
		router:SetPos( Pos )
		router:Spawn()
		
		// Make it a satellite modem
		router:MakeWireless()

		// Add it to the counter
		pl:AddCount( "computers", router )
		
		// Make the effect
		DoPropSpawnedEffect( router )

		// Return the entity
		return router
		
	end

end

function TOOL:UpdateGhost( ent, player )

	if ( !ent || !ent:IsValid() ) then return end

	local tr 	= utilx.GetPlayerTrace( player, player:GetCursorAimVector() )
	local trace 	= util.TraceLine( tr )
	
	if (!trace.Hit || trace.Entity:IsPlayer() || trace.Entity:GetClass() == "pcmod_pc" ) then
		ent:SetNoDraw( true )
		return
	end
	
	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	ent:SetAngles( Ang )	

	local min = ent:OBBMins()
	ent:SetPos( trace.HitPos - trace.HitNormal * min.z )
	
	ent:SetNoDraw( false )

end

function TOOL:Think()
	if (!self.GhostEntity || !self.GhostEntity:IsValid() || self.GhostEntity:GetModel() != self:GetClientInfo( "model" )) then
		self:MakeGhostEntity( self:GetClientInfo( "model" ), Vector(0,0,0), Angle(0,0,0) )
	end
	
	self:UpdateGhost( self.GhostEntity, self:GetOwner() )
end

function TOOL.BuildCPanel( CPanel )

	// HEADER
	CPanel:AddControl( "Header", { Text = "#Tool_pc_name", Description	= "#Tool_pc_desc" }  )

	// BODY
	CPanel:AddControl( "CheckBox", { Label = "#Weld",
									 Command = "pc_weld" } )
									 
	CPanel:AddControl( "Textbox", { Label = "Password:",
									MaxLength = 16,
									Command = "router_password" } )
end